//---------------------------------------------------------------------------

#include <vcl.h>
#include <inifiles.hpp>
#include <stdio.h>
#include <math.h>
#include <mem.h>
#include <time.h>
#pragma hdrstop

#include "dcfhga1.h"
#include "Sound.h"
#include "Filters.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#define DCF_HGA 1
#define RWM 2
#define SND_LEN 1440
#define MSG_BIT_LEN 11
#define BLEN 60   //    
#define MASK_LEN 160
// 120 + 60 -20 -     2\3 

#define BW 200.0//200.0
#define DF 340
#define BW_RWM 50.0
#define DF_RWM 500
#define BW_F 50.0 //  
#define DF_LEN 1024 // 

#define DT_HIST_LEN 10 //     dT

TForm1 *Form1;

TSound *snd;
int freq;
bool CHANNEL_LEFT=true;
bool USE_TWO_FILTERS=true;
double Usred, Uh, Ul;
float x[SND_LEN+2], y[SND_LEN+2], x1[SND_LEN+2], x2[SND_LEN+2], xf[SND_LEN+2], xf2[SND_LEN+2];
bool AUDIO_RX_WORKED;
HANDLE hAudioRx;
TFilter * BPF1, *BPF2;
//TIIR_DCFHGA * BPF1, * BPF2;
TIIRBPF2 * BPF_F, * BPF_F2; //    
double Ubpf1, Ubpf2, Uf, Uf2;

double deltaF, d_deltaF, df0[DF_LEN+2];
int cnt_F;
long int deltaT;
double dThist[DT_HIST_LEN+2];
int i_dth=0; //   dThist
int wait_dt=DT_HIST_LEN;

double dcfhga_delay; //      
double dcf_delay;    //   DCF    
double hga_delay;    //   HGA    
double dT_tol;       //       

int cnt_T;
float SNR;
int UTC_TIME_DIF;
int CNT_T_EQ;
AnsiString rxfile, dffile, dtfile;
bool PARITY_CHECK_ENABLE, NB_ENABLE;
double NB_THRESHOLD, NB_THRESHOLD_USER;
int MODE;
unsigned long CNT_Z=0; //   
unsigned long CNT_Z_ALL=0;//c  
//double SNR_DB_SHIFT;
bool WRITE_DF, WRITE_DT;
int WRITE_DF_PERIOD, WRITE_DF_PERIOD_USER;
long last_rwm_time;
/////////////////////////////////////////////////////////////////////////////////
DWORD WINAPI AudioRxThread( LPVOID )
 {
  double U,U2,U3, U4;
  unsigned char U1[SND_LEN+2];
  int C1=0, C2=0; //0  1   
  bool START=false, STOP=false, START_SEC=false; //    
  int CNT=0; //    

  int MC1=6; //  

  float ddu=1; //       
  int samples_queue=0;
  int start_queue=0;

  int i_start=0; //  
  int B[MSG_BIT_LEN+2]; //    ,  1   
  int CNT_B=0; //   
  /*
  unsigned char MASK[MASK_LEN+2]; //    -
  for(int i=0; i<=MASK_LEN; i++) if(i<MASK_LEN-40)MASK[i]=1; else MASK[i]=0;
   */
  int cnt_stop=0;

  memset(U1,0,sizeof(U1));
  Usred=0; U2=0, U3=0;
  AnsiString bs;
  unsigned char msg[128];
  memset(msg,0,sizeof(msg));
  int i_msg=0;

  deltaT=0;  cnt_T=0;
  Ubpf1=Ubpf2=Uf=Uf2=0.0;
  deltaF=0;
  cnt_F=0;
  for(int i=0; i<DF_LEN; i++) df0[i]=0;
  
  while(1)
  {AUDIO_RX_WORKED=true;
   try{
     if(CHANNEL_LEFT)samples_queue=snd->read(x,y,SND_LEN);
     else samples_queue=snd->read(y,x,SND_LEN);
     
     //    
     float uu=0;
     for(int i=0; i<SND_LEN; i++) uu=uu+fabs(x[i]);
     Usred=0.95*Usred+0.05*(uu/SND_LEN);   /// 0.99 0.01

     //  
     int cnt_nb=0;
     if(NB_ENABLE)
     { for(int i=0; i<SND_LEN; i++) if(fabs(x[i])>NB_THRESHOLD*Usred){ x[i]=0; cnt_nb++;}
       if(cnt_nb>SND_LEN/20) {Form1->Image1->Visible=true;/*NB_THRESHOLD+=1.0;*/}
       else {Form1->Panel1->Font->Color=clBlack;Form1->Image1->Visible=false;}
       //if(cnt_nb==0) NB_THRESHOLD-=0.05;
       //if(NB_THRESHOLD<3.0)NB_THRESHOLD=3.0; if(NB_THRESHOLD>100.0) NB_THRESHOLD=100.0;
       AnsiString s; s.sprintf("%.1f dB",20.0*log10(NB_THRESHOLD));
       Form1->Label6->Caption=s;
     }
     else {Form1->Panel1->Font->Color=clBlack;Form1->Image1->Visible=false;}

     //    DCF39  HGA22     


     BPF1->filter(x,SND_LEN,x1);
     BPF2->filter(x,SND_LEN,x2);

     BPF_F->filter(x,SND_LEN,xf);
     BPF_F2->filter(x,SND_LEN,xf2);
  // snd->write(x,x,SND_LEN);

     float uu1=0, uu2=0, uuf=0, uuf2=0;

     uu=uu/SND_LEN;
     for(int i=0; i<SND_LEN; i++) uu1=uu1+fabs(x1[i]);
     if(USE_TWO_FILTERS)Ubpf1=0.9*Ubpf1+0.1*(uu1/SND_LEN); //0.9 0.1
     else Ubpf1=0.95*Ubpf1+0.05*(uu1/SND_LEN);
     uu1=uu1/SND_LEN; //uu1=0;
     for(int i=0; i<SND_LEN; i++) uu2=uu2+fabs(x2[i]);
     Ubpf2=0.9*Ubpf2+0.1*(uu2/SND_LEN); //0.9 0.1
     uu2=uu2/SND_LEN; //uu2=0;
     for(int i=0; i<SND_LEN; i++) uuf=uuf+fabs(xf[i]);
     Uf=0.7*Uf+0.3*(uuf/SND_LEN); //0.9 0.1
     for(int i=0; i<SND_LEN; i++) uuf2=uuf2+fabs(xf2[i]);
     Uf2=0.7*Uf2+0.3*(uuf2/SND_LEN);

     //  
     AnsiString ss;
     if(Usred>0.0001) ss.sprintf("%.1f dB", 20*log10(Usred));
     else ss="weak";
     if(Usred>0.5) {Form1->Label5->Font->Color=clRed; ss+=" over";}
     else Form1->Label5->Font->Color=clNavy;
     Form1->Label5->Caption=ss;
     Form1->Label5->Hint="Input Level="+AnsiString(Usred);
      Form1->ProgressBar1->Hint="Filtr 2 = "+AnsiString(Ubpf2);
      Form1->ProgressBar2->Hint="Filtr 1 = "+AnsiString(Ubpf1);
     if(Usred>0)
     {Form1->ProgressBar2->Position=100*uu1/(Ubpf1+Ubpf2);//Usred*100;
      Form1->ProgressBar1->Position=100*uu2/(Ubpf1+Ubpf2);///Usred*100;
      if(Uf<Uf2)SNR=20.0*log10(Uf/(Uf2-Uf));
      AnsiString ssnr; ssnr.sprintf("%.1fdB",SNR);
      Form1->Label4->Caption=ssnr;
      Form1->ProgressBar2->Repaint(); Form1->ProgressBar1->Repaint();
     }


    //        
     for(int i=0; i<SND_LEN; i++)
     { x1[i]=fabs(x1[i]); x2[i]=fabs(x2[i]); //    1  2 
       if(Ubpf1>0) ddu=Ubpf2/Ubpf1; else ddu=1;
       U2=0.9*U2+0.1*(x1[i]-x2[i]); //      
       U3=0.9*U3+0.1*(x1[i]-Ubpf1/2.0); //   1- 
       U4=0.9*U4+0.1*(x2[i]-Ubpf2/2.0); //   2- 
       if(USE_TWO_FILTERS)U=U2; else U=U3;
        //if(freq==135500) U=U3;
        //if(ddu<3 && ddu> 0.33) U=U2; //     
        //else U=U3; //          
       if(MODE==RWM)U=U3;     //   CW 

       // 
       //  200   12000 SR    60 
       MC1=6;
       if(U>0) C1++; else C1--;
       if(C1>MC1) C1=MC1; if(C1<-(MC1-1)) C1=-(MC1-1);    //30   5   6
       if(C1>0)U1[i]=1; else U1[i]=0;

       /*
       static int u_prev, i_prev;
       static int gg_min;
       if(u_prev!=U1[i]){
        int gg=i-i_prev;
        if(gg<0) gg+=SND_LEN;
        if(gg<gg_min) gg_min=gg;
        if(gg_min<20) {MC1++; gg_min=40; }
        if(gg_min>60) {MC1--; gg_min=40; }
        if(MC1>60)MC1=60; if(MC1<2)MC1=2;
        u_prev=U1[i]; i_prev=i;
       }
       */
     }

     //      
      {
        float ddf=0;
        if(SNR > 3.0 && uu1>1.4*uu2 && Usred>0.001)
        {
         //   
         for(int i=0; i<SND_LEN-1; i++)
         { if(xf[i]<0 && xf[i+1]>=0) CNT_Z++;
           if(xf[i]>=0 && xf[i+1]<0) CNT_Z++;
           CNT_Z_ALL++;
         }
         if(CNT_Z_ALL/12000.0>=2.0)
         {ddf=(12000.0*CNT_Z/2.0/CNT_Z_ALL)-12000*BPF_F->getF0();
          if(CNT_Z_ALL/12000.0>=100.0){CNT_Z_ALL=CNT_Z_ALL/2; CNT_Z=CNT_Z/2;}

          df0[cnt_F]=ddf;
          cnt_F++; cnt_F=cnt_F%DF_LEN;
          int cf=1;
          float df=0;
          for(int i=0; i<DF_LEN; i++)
          {
           if(df0[i]!=0) {cf++; df+=df0[i];}
          }
          deltaF=df/cf;
          d_deltaF=0;
          for(int i=0; i<DF_LEN; i++)
          { if(df0[i]!=0) {d_deltaF+=(df0[i]-deltaF)*(df0[i]-deltaF);}
          }
          d_deltaF=3.0*sqrt(d_deltaF)/cf;
         }
        }
      }

    //------------------ RWM --------------------------------------------------
    if(MODE==RWM && Usred>0.001)
    {//           -  
     //          19  20   49  50, 
     //     ,  10      
     STOP=false;START=false;
     START_SEC=false;
     int cnt_1=0;
     for(int j=0; j<SND_LEN-1; j++) //    -    ,   
     { if(U1[j]==1)cnt_1++; }
     //    -  
     if(cnt_1>SND_LEN*0.95) STOP=true; //  100 
     if(cnt_1>SND_LEN*0.8 && cnt_1<SND_LEN*0.95) START_SEC=true; //  100  -  
     if(STOP)cnt_stop++; //     ?
     else {  //   .   ?
      if(cnt_stop>=3) //   500   
      {//     ?   ,  
       time_t t=time(NULL);
       if(t-last_rwm_time>50)
       { START=true;STOP=false;START_SEC=false;
         last_rwm_time=t;
       }
       if(t<last_rwm_time)last_rwm_time=t;
      }
      cnt_stop=0;
          }
     if(START) //  
     { Form1->Panel1->Color=clLime;Form1->Panel1->Repaint();
       time_t t;
          long t1;
          struct tm *t_cur;
          t = time(NULL);
          t_cur=gmtime(&t);
          long int dt;
          if(t_cur->tm_sec>30)dt=t_cur->tm_sec-60;
          else dt=t_cur->tm_sec;
          dt=dt-1;
          //  
           if(dt==deltaT /*|| dt==(deltaT-1) || dt==(deltaT+1)*/)cnt_T++;
           else cnt_T=0;
           deltaT=dt;
           if(dt<1 && dt>-1) Form1->Label2->Font->Color=clGreen;
           else Form1->Label2->Font->Color=clMaroon;
           AnsiString ss;
           ss.sprintf("RWM time: dT=%d s  cnt=%d", deltaT, cnt_T);
           Form1->StatusBar1->SimpleText=ss;
           if(Form1->CheckBox1->Checked)
           {
             if(cnt_T>=CNT_T_EQ && (deltaT>=1 || deltaT<=-1))
             {t = time(NULL)-deltaT; stime(&t); cnt_T=0; // ,   10    
              AnsiString ss;
              ss.sprintf("Time correction: dT=%d",deltaT);
              Form1->StatusBar1->SimpleText=ss;
              FILE *fp=fopen(rxfile.c_str(),"a");
              fprintf(fp,"TIME CORRECTION: %d s of RWM time\n",deltaT);
              for(int k=0; k<16; k++) fprintf(fp,"%d, ", msg[k]);
              fprintf(fp,"\n");
              fclose(fp);
             }
           }
          ////
     }
     if(SNR>2 && Ubpf1>1.5*Ubpf2){Form1->Panel1->Color=clYellow;}
     else
      if(STOP==false && START==false /*&& START_SEC==false*/)Form1->Panel1->Color=clGray;
     if(START && SNR>2) {Form1->Panel1->Color=clGreen;}
     if(START_SEC && SNR>2) {Form1->Panel1->Color=clGreen;}
     if(STOP && SNR>2){Form1->Panel1->Color=clLime;}
     Form1->Panel1->Repaint();
     continue;
    } // end RWM

    //------------------ DCF  HGA --------------------------------------------
    //   
     STOP=true;
     int cnt_1=0;
     for(int i=0; i<SND_LEN-1; i++){ if(U1[i]==1)cnt_1++; }
     if(cnt_1>SND_LEN*0.8) STOP=true; else STOP=false;
     if(STOP) Form1->Panel1->Color=clGreen; // 
     else     Form1->Panel1->Color=clGray;  // 

     static int CC1;
     static bool ST;
     for(int i=0; i<SND_LEN-1; i++)
     { if(U1[i]>0) CC1++; else CC1--;
       if(CC1>60){CC1=60; ST=true;} if(CC1<-60) {CC1=-60;ST=false;}
       if(!START && ST && abs(CC1)<1) {
         i_start=i; START=true; ST=false; CNT=0; CNT_B=0; C2=0; memset(B,-1,sizeof(B));
         start_queue=SND_LEN-i_start;
         //break;
       }
     }
    /*
    if(!START) //    -    1  0    ()
    {i_start=0;
     for(int i=0; i<SND_LEN-MASK_LEN; i++)  //-20
      { if(memcmp(&U1[i],MASK,MASK_LEN)==0)
        {START=true; i_start=i+MASK_LEN+20; CNT=0; CNT_B=0; C2=0; memset(B,-1,sizeof(B));
         start_queue=SND_LEN-i_start;
         break;
        }
      }
    }
     */
    //   ,     ,     
   if(START)
   {  Form1->Panel1->Color=clLime;
    for(int i=i_start; i<SND_LEN; i++)
    {  if(!START) break;
       if(U1[i]==1) C2++; else C2--;
       CNT++;
       if(CNT==BLEN) //  ,    
       { CNT=0;
         if(C2>0)B[CNT_B]=1;else B[CNT_B]=0;
         C2=0;  CNT_B++;
       }
     if(i_start<SND_LEN)i_start=0; //        

     //     -   
     unsigned char symb=0;
     if(CNT_B>=MSG_BIT_LEN)
     { //   
       CNT_B=0;
       int parity_bit=B[0]^B[1]^B[2]^B[3]^B[4]^B[5]^B[6]^B[7];
       int cc=(B[7]*128+B[6]*64+B[5]*32+B[4]*16+B[3]*8+B[2]*4+B[1]*2+B[0]);
       symb=0xff & cc;
       if(PARITY_CHECK_ENABLE && B[8]!=parity_bit){ symb=0;i_msg=0;}
       else msg[i_msg]=symb; i_msg++;

       if(i_msg==1 && symb!=0x68)  //     68h ?
         {  START=false;  //  
            Form1->Panel1->Color=clYellow;
            /*
            try{
              FILE *fp=fopen(rxfile.c_str(),"a");
              fprintf(fp,"ERR: %x\n",symb);
              fclose(fp);
              }catch(...){}
            */
            memset(msg,0,sizeof(msg));
            i_msg=0;
         }

       if(B[8]==1 && B[9]==1 && B[10]==1 && cc==0xff){ symb=0x16;}//   ,   

       memset(B,-1,sizeof(B));
     }

     if((symb==0x16 && i_msg>9) || i_msg>25) // 
     { START=false;
       Form1->Panel1->Color=clGray;
       if(msg[0]==0x68 && msg[3]==0x68)
       { AnsiString ss;
         bs="";
        int chksum=0;
        for(int i=4; i<i_msg-2; i++) chksum+=msg[i];
        chksum=chksum&0x00ff;
        if(!PARITY_CHECK_ENABLE) chksum=msg[i_msg-2]; //   CRC
        if(i_msg>8 && msg[1]==msg[2] && msg[6]==0 && msg[7]==0 && chksum==msg[i_msg-2]) //  6  7 -   ==0
        { time_t t;
          long t1;
           struct tm *t_cur;
           struct tm t_rcvd ;
           TIME_ZONE_INFORMATION tzi;
           memset(&t_rcvd,0,sizeof(t_rcvd));
           t = time(NULL);
           t_cur=gmtime(&t);
           GetTimeZoneInformation(&tzi);
           int summer=(msg[10]&0xe0)>>5;  //??   =0
           if(summer) summer=1;
           t_rcvd.tm_sec=(msg[8]&0xfc)>>2;
            if(t_rcvd.tm_sec<0 || t_rcvd.tm_sec>59) goto M1;
           t_rcvd.tm_min=msg[9];
            if(t_rcvd.tm_min<0 || t_rcvd.tm_min>59) goto M1;
           t_rcvd.tm_hour=(msg[10]&0x1f); // GMT =   -2 
            if(t_rcvd.tm_hour<0 || t_rcvd.tm_hour>23) goto M1;
           t_rcvd.tm_mday=msg[11]&0x1f;
            if(t_rcvd.tm_mday<0 || t_rcvd.tm_mday>31) goto M1;
           t_rcvd.tm_mon=msg[12]-1;
            if(t_rcvd.tm_mon<0 || t_rcvd.tm_mon>12) goto M1;
           t_rcvd.tm_year=msg[13] + 100;
            if(t_rcvd.tm_year<123 || t_rcvd.tm_year>223) goto M1; //     100  ;)
           t_rcvd.tm_isdst=t_cur->tm_isdst;
           t1=mktime(&t_rcvd) -UTC_TIME_DIF*3600 - summer*3600;


           long int dt=t-t1+tzi.Bias*60; //+_timezone;
           double snd_card_delay= (samples_queue+start_queue)/12000.0;   // - 

           double dtf=(double)dt /*+ 1.0 * syst.wMilliseconds / 1000.0 */- dcfhga_delay - snd_card_delay; //  !
           dThist[i_dth]=dtf;
           i_dth++; if(i_dth>=DT_HIST_LEN) i_dth=0; // dt
           wait_dt--;
           if(wait_dt<0)
            wait_dt=0;

            if(WRITE_DT)
            {
               try{
                 FILE *fp=fopen(dtfile.c_str(),"a");
                 fprintf(fp,"%02d/%02d/%04d %02d:%02d:%02d dT = %.3f s\n",t_cur->tm_mday, t_cur->tm_mon, t_cur->tm_year+1900, t_cur->tm_hour, t_cur->tm_min, t_cur->tm_sec  ,dtf);
                 fclose(fp);
                  }catch(...){}
            }

           //if(dt==deltaT || dt==(deltaT-1) || dt==(deltaT+1))cnt_T++;
           if(abs(dt-deltaT)<=2)cnt_T++;
           else cnt_T=0;
           deltaT=dt;
           //if(dt<2 && dt>-2) Form1->Label2->Font->Color=clGreen;
           if(fabs(dtf)<dT_tol) Form1->Label2->Font->Color=clGreen;
           else Form1->Label2->Font->Color=clMaroon;
           if(Form1->CheckBox1->Checked)
           {
             //if(cnt_T>=CNT_T_EQ && (deltaT>1 || deltaT<-1))
             if(cnt_T>=CNT_T_EQ && fabs(dtf)>dT_tol)
             {int ddd=0;
              if(dtf<0) ddd=floor(dtf); else ddd=ceil(dtf);
              time_t t_new = t - ddd -tzi.Bias*60;
              //    
              long dms=1000*fabs(ddd-dtf);
              SYSTEMTIME syst; GetSystemTime(&syst); //   
              WORD ms1=syst.wMilliseconds;
              WORD ms2;
              do {
                GetSystemTime(&syst);
                ms2 = syst.wMilliseconds;
                if(ms2<ms1) ms2+=1000;
              } while (ms2-ms1<dms);
              //Sleep(1000*fabs(ddd-dtf));
              stime(&t_new);  // 
              cnt_T=0;
              i_dth=0; wait_dt=DT_HIST_LEN;
              memset(dThist,0,sizeof(dThist));
              try{
              FILE *fp=fopen(rxfile.c_str(),"a");
              fprintf(fp,"TIME CORRECTION: %02u/%02u/%04u %02u:%02u:%02u dT=%d (%dh)\n",t_rcvd.tm_mday,t_rcvd.tm_mon+1,t_rcvd.tm_year+1900,t_rcvd.tm_hour,t_rcvd.tm_min,t_rcvd.tm_sec,deltaT,UTC_TIME_DIF+summer);
              for(int k=0; k<16; k++) fprintf(fp,"%d, ", msg[k]);
              fprintf(fp,"\n");
              fclose(fp);
              }catch(...){}
             }
           }
          ss.sprintf("TLG#%d: %02u/%02u/%04u %02u:%02u:%02u (+%dh) dT=%.2fs cnt=%d",(msg[4]&0xf0)>>4,t_rcvd.tm_mday,t_rcvd.tm_mon+1,t_rcvd.tm_year+1900,t_rcvd.tm_hour,t_rcvd.tm_min,t_rcvd.tm_sec,UTC_TIME_DIF+summer,dtf,cnt_T);
           bs=ss;
           /*
           try{
              FILE *fp=fopen(rxfile.c_str(),"a");
              fprintf(fp,"%s\n",ss);
              fclose(fp);
              }catch(...){}
           */
        }
        else
        { bs.sprintf("TLG#%d: L=%d",(msg[4]&0xf0)>>4,msg[1]);
          if(chksum!=msg[i_msg-2]) bs=bs+" (CRC BD)";
          /*
          try{
              FILE *fp=fopen(rxfile.c_str(),"a");
              fprintf(fp,"> ");
              for(int k=0; k<i_msg; k++) fprintf(fp,"%x, ", msg[k]);
              fprintf(fp," CRC=%x\n",chksum );
              fclose(fp);
              }catch(...){}
          */
        }
        Form1->StatusBar1->SimpleText=bs;
       }
M1:    memset(msg,0,sizeof(msg));
       i_msg=0;
       bs="";
     }  // if  
    }//for  i
    if(i_start>=SND_LEN) i_start-=SND_LEN;
   } // if(START)

   }catch(...){}
   Sleep(2);
  }// end while(1)
 }

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
 TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
 rxfile=ini->ReadString("FILE","PATH","TimeLog.txt");
 ini->WriteString("FILE","PATH",rxfile);
 dffile=ini->ReadString("FILE","DF_PATH","df.txt");
 ini->WriteString("FILE","DF_PATH",dffile);
 WRITE_DF=ini->ReadBool("FILE","WRITE_DF_TO_FILE",false);
 ini->WriteBool("FILE","WRITE_DF_TO_FILE",WRITE_DF);
 WRITE_DF_PERIOD=ini->ReadInteger("FILE","WRITE_DF_PERIOD_MIN",15);
 if(WRITE_DF_PERIOD<1)WRITE_DF_PERIOD=1;
 if(WRITE_DF_PERIOD>59)WRITE_DF_PERIOD=59;
 WRITE_DF_PERIOD_USER=WRITE_DF_PERIOD;
 ini->WriteInteger("FILE","WRITE_DF_PERIOD_MIN",WRITE_DF_PERIOD);

 dtfile=ini->ReadString("FILE","DT_PATH","dt.txt");
 ini->WriteString("FILE","DT_PATH",dtfile);
 WRITE_DT=ini->ReadBool("FILE","WRITE_DT_TO_FILE",false);
 ini->WriteBool("FILE","WRITE_DT_TO_FILE",WRITE_DT);

 int sound_device=ini->ReadInteger("AUDIO","SND_INPUT",-1);
 ini->WriteInteger("AUDIO","SND_INPUT",sound_device);
 CHANNEL_LEFT=ini->ReadBool("AUDIO","USE_LEFT_CHANNEL",true);
 ini->WriteBool("AUDIO","USE_LEFT_CHANNEL",CHANNEL_LEFT);
 if(CHANNEL_LEFT) SoundInputLEFT1->Checked=true;
 else SoundInputRIGHT1->Checked=true;
 NB_ENABLE=ini->ReadBool("AUDIO","NB_ENABLE",true);
 ini->WriteBool("AUDIO","NB_ENABLE",NB_ENABLE);
 NB_THRESHOLD=ini->ReadFloat("AUDIO","NB_THRESHOLD_DB",20.0);
 if(NB_THRESHOLD<3.0) NB_THRESHOLD=3.0;
 ini->WriteFloat("AUDIO","NB_THRESHOLD_DB",NB_THRESHOLD);
 USE_TWO_FILTERS=ini->ReadBool("AUDIO","DEMOD_USE_2_FILTERS",true);
 ini->WriteBool("AUDIO","DEMOD_USE_2_FILTERS",USE_TWO_FILTERS);
 if(USE_TWO_FILTERS) twofiltersdetectors1->Checked=true;
 else  N1filterdetector1->Checked=true;
 ProgressBar1->Visible=USE_TWO_FILTERS;

 CheckBox1->Checked=ini->ReadBool("TIME_CORRECTION","ENABLE",true);
 ini->WriteBool("TIME_CORRECTION","ENABLE",CheckBox1->Checked);
 UTC_TIME_DIF=ini->ReadInteger("TIME_CORRECTION","EU_GMT_TIME_DIF",1);
 ini->WriteInteger("TIME_CORRECTION","EU_GMT_TIME_DIF",UTC_TIME_DIF);
 CNT_T_EQ=ini->ReadInteger("TIME_CORRECTION","COUNT_DT_EQUAL",5);
 if(CNT_T_EQ<3)CNT_T_EQ=3;
 ini->WriteInteger("TIME_CORRECTION","COUNT_DT_EQUAL",CNT_T_EQ);

 dT_tol=ini->ReadFloat("TIME_CORRECTION", "DT_TOLERANCE", 0.5);
 if(dT_tol>1.5) dT_tol=1.5; if(dT_tol<0.1) dT_tol=0.1;
 ini->WriteFloat("TIME_CORRECTION", "DT_TOLERANCE",dT_tol);

 dcf_delay=ini->ReadFloat("TIME_CORRECTION", "DCF_DELAY_MS", 80.0);
 if(dcf_delay<-2000) dcf_delay=-2000;  if(dcf_delay>2000) dcf_delay=2000;
 ini->WriteFloat("TIME_CORRECTION", "DCF_DELAY_MS",dcf_delay);
 dcf_delay=dcf_delay/1000.0;

 hga_delay=ini->ReadFloat("TIME_CORRECTION", "HGA_DELAY_MS", 100.0);
 if(hga_delay<-2000) hga_delay=-2000;  if(hga_delay>2000) hga_delay=2000;
 ini->WriteFloat("TIME_CORRECTION", "HGA_DELAY_MS",hga_delay);
 hga_delay=hga_delay/1000.0;


 freq=ini->ReadInteger("FREQ","DIAL",136000);
 ini->WriteInteger("FREQ","DIAL",freq);

 PARITY_CHECK_ENABLE=ini->ReadBool("DATA","PARITY_CHECK_ENABLE",true);
 ini->WriteBool("DATA","PARITY_CHECK_ENABLE",PARITY_CHECK_ENABLE);
 CheckBox3->Checked=PARITY_CHECK_ENABLE;

 CheckBox2->Checked= NB_ENABLE;
 delete ini;

 int n;
 WAVEINCAPS pwic;
 n=waveInGetNumDevs();
 for(unsigned int i=0; i<n; i++)
 { waveInGetDevCaps(i,&pwic,sizeof(pwic));
   AnsiString DevName=pwic.szPname;
   ComboBox1->Items->Add(DevName);
  if(i==sound_device)ComboBox1->Text=DevName;
 }
 Form1->DoubleBuffered=true;
 try{
 DeleteFile(rxfile+".old");
 RenameFile(rxfile,rxfile+".old");
 FILE *fp=fopen(rxfile.c_str(),"w+");
 fprintf(fp,"DCF/HGA Time log:\n");
 DateSeparator='/';
 TimeSeparator=':';
 AnsiString str_t = FormatDateTime("dd/mm/yyyy hh:mm:ss", Now());
 fprintf(fp,"%s STARTED \n",str_t.c_str());      
 fclose(fp);
 DeleteFile(dffile); DeleteFile(dtfile);
 }catch(...){}
  memset(x,0,sizeof(x));
  memset(y,0,sizeof(y));
  memset(x1,0,sizeof(x1));
  memset(x2,0,sizeof(x2));
  memset(xf,0,sizeof(xf));
 snd=new TSound();
 snd->IN_DEVICE=sound_device;
 snd->openIn(12000,16,2,SND_LEN);
 snd->OUT_DEVICE=sound_device;
 snd->openOut(12000,16,2,SND_LEN);
 BPF1=new TFilter((2830.0-BW)/12000,(2830.0+BW)/12000);
 BPF2=new TFilter((2830.0+DF-BW)/12000,(2830.0+DF+BW)/12000);
 //BPF1=new TIIR_DCFHGA(2830, BW);
 //BPF2=new TIIR_DCFHGA(2830.0+DF,BW);
 BPF_F=new TIIRBPF2(2830.4/12000, BW_F/12000);
 BPF_F2=new TIIRBPF2(2830.4/12000, BW_F*10.0/12000);
 MODE=DCF_HGA;
 dcfhga_delay=dcf_delay;
 switch(freq)
 { case 136000: RadioButton1->Checked=true; break;
   case 135500: RadioButton2->Checked=true; break;
   case 135000: RadioButton3->Checked=true; break;
   case 9995: RadioButton4->Checked=true; break;
   default: RadioButton1->Checked=true;
 }
 
 user1->Visible=false;
 switch(WRITE_DF_PERIOD)
 { case 5: N5min1->Checked=true; break;
   case 10: N10min1->Checked=true; break;
   case 15: N15min1->Checked=true; break;
   case 20: N20min1->Checked=true; break;
   case 30: N30min1->Checked=true; break;
   default: user1->Caption=AnsiString(WRITE_DF_PERIOD)+" min";
            WRITE_DF_PERIOD_USER= WRITE_DF_PERIOD;
            user1->Visible=true;
            user1->Checked=true;
 }

 user2->Visible=false;
 switch((int)NB_THRESHOLD)
 { case 10: N10dB1->Checked=true; break;
   case 15: N15dB1->Checked=true; break;
   case 20: N20dB1->Checked=true; break;
   case 25: N25dB1->Checked=true; break;
   default: user2->Caption=AnsiString(NB_THRESHOLD);
            NB_THRESHOLD_USER = NB_THRESHOLD;
            user2->Visible=true;
            user2->Checked=true;
 }
 NB_THRESHOLD=pow(10,(NB_THRESHOLD/20));
 
 if(CHANNEL_LEFT) Label1->Caption="Sound Input (L):";
 else Label1->Caption="Sound Input (R):";

 writedTtologfile1->Checked=WRITE_DT;
 WritedFtoLogFile1->Checked=WRITE_DF;

  DWORD RxThreadId;
  AUDIO_RX_WORKED=false;
  hAudioRx=CreateThread(NULL,0,AudioRxThread,0,CREATE_SUSPENDED,&RxThreadId);
  SetThreadPriority(hAudioRx, THREAD_PRIORITY_TIME_CRITICAL);
 if(!AUDIO_RX_WORKED){ResumeThread(hAudioRx);}
 Form1->DoubleBuffered=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
  if(floor(BPF1->getF0()*12000)!= 2830)    //DCF39
  { if(AUDIO_RX_WORKED){SuspendThread(hAudioRx); AUDIO_RX_WORKED=false; Sleep(100);}
    delete BPF1;   delete BPF2;
    BPF1=new TFilter((2830.0-BW)/12000,(2830.0+BW)/12000);
    BPF2=new TFilter((2830.0+DF-BW)/12000,(2830.0+DF+BW)/12000);
    //BPF1=new TIIR_DCFHGA(2830, BW);
    //BPF2=new TIIR_DCFHGA(2830.0+DF,BW);
    BPF_F=new TIIRBPF2(2830.4/12000, BW_F/12000);
    BPF_F2=new TIIRBPF2(2830.4/12000, BW_F*10.0/12000);
    Panel1->Caption="DCF39";
    MODE=DCF_HGA;
    CheckBox2->Enabled=true;
    Label3->Caption="dF=___ Hz";
    Form1->StatusBar1->SimpleText="DCF39";
    dcfhga_delay=dcf_delay;
    CNT_Z=CNT_Z_ALL=0;
      cnt_F=0;
      for(int i=0; i<DF_LEN; i++) df0[i]=0;

    freq=136000;
    try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteInteger("FREQ","DIAL",freq);
    delete ini;
    FILE *fp=fopen(rxfile.c_str(),"a");
    DateSeparator='/';
    TimeSeparator=':';
    AnsiString str_t = FormatDateTime("dd/mm/yyyy hh:mm:ss", Now());
    fprintf(fp,"%s DIAL FREQ = %d \n",str_t.c_str(), freq);
    fclose(fp);
    }catch(...){}
    if(!AUDIO_RX_WORKED){ResumeThread(hAudioRx);}
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton2Click(TObject *Sender)
{
 if(floor(BPF1->getF0()*12000)!= 3330)     // DCF39
 { if(AUDIO_RX_WORKED){SuspendThread(hAudioRx); AUDIO_RX_WORKED=false; Sleep(100);}
   delete BPF1;  delete BPF2;
   BPF1=new TFilter((3330.0-BW)/12000,(3330.0+BW)/12000);
   BPF2=new TFilter((3330.0+DF-BW)/12000,(3330.0+DF+BW)/12000);
   //BPF1=new TIIR_DCFHGA(3330, BW);
   //BPF2=new TIIR_DCFHGA(3330.0+DF,BW);
   BPF_F=new TIIRBPF2(3330.4/12000, BW_F/12000);
   BPF_F2=new TIIRBPF2(3330.4/12000, BW_F*10.0/12000);
   Panel1->Caption="DCF39";
   Form1->StatusBar1->SimpleText="DCF39";
   dcfhga_delay=dcf_delay;
   MODE=DCF_HGA;
   CheckBox2->Enabled=true;
   Label3->Caption="dF=___ Hz";
   CNT_Z=CNT_Z_ALL=0;
    cnt_F=0;
    for(int i=0; i<DF_LEN; i++) df0[i]=0;
   freq=135500;

   try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteInteger("FREQ","DIAL",freq);
    delete ini;
    FILE *fp=fopen(rxfile.c_str(),"a");
    DateSeparator='/';
    TimeSeparator=':';
    AnsiString str_t = FormatDateTime("dd/mm/yyyy hh:mm:ss", Now());
    fprintf(fp,"%s DIAL FREQ = %d \n",str_t.c_str(), freq);
    fclose(fp);
    }catch(...){}
   if(!AUDIO_RX_WORKED){ResumeThread(hAudioRx);}
 }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton3Click(TObject *Sender)
{
 if(floor(BPF1->getF0()*12000)!= 430)     //HGA22
 { if(AUDIO_RX_WORKED){SuspendThread(hAudioRx); AUDIO_RX_WORKED=false; Sleep(100);}
   delete BPF1;   delete BPF2;
   BPF1=new TFilter((430.0-BW)/12000,(430.0+BW)/12000);
   BPF2=new TFilter((430.0+DF-BW)/12000,(430.0+DF+BW)/12000);
   //BPF1=new TIIR_DCFHGA(430, BW);
   //BPF2=new TIIR_DCFHGA(430.0+DF,BW);
   BPF_F=new TIIRBPF2(430.0/12000, BW_F/12000);
   BPF_F2=new TIIRBPF2(430.4/12000, BW_F*10.0/12000);
   Panel1->Caption="HGA22";
   Form1->StatusBar1->SimpleText="HGA22";
   dcfhga_delay=hga_delay;
   MODE=DCF_HGA;
   CheckBox2->Enabled=true;
   Label3->Caption="dF=___ Hz";
   CNT_Z=CNT_Z_ALL=0;
    cnt_F=0; 
    for(int i=0; i<DF_LEN; i++) df0[i]=0;
   freq=135000;
  
   try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteInteger("FREQ","DIAL",freq);
    delete ini;
    FILE *fp=fopen(rxfile.c_str(),"a");
    DateSeparator='/';
    TimeSeparator=':';
    AnsiString str_t = FormatDateTime("dd/mm/yyyy hh:mm:ss", Now());
    fprintf(fp,"%s DIAL FREQ = %d \n",str_t.c_str(), freq);
    fclose(fp);
    }catch(...){}
   if(!AUDIO_RX_WORKED){ResumeThread(hAudioRx);}
 }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
 int sound_device=ComboBox1->ItemIndex;
 try{
 TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
 ini->WriteInteger("AUDIO","SND_INPUT",sound_device);
 delete ini;
 }catch(...){}
  memset(x,0,sizeof(x));
  memset(x1,0,sizeof(x1));
   memset(x2,0,sizeof(x2));
 delete snd;
 snd=new TSound();
 snd->IN_DEVICE=sound_device;
 snd->openIn(12000,16,1,SND_LEN);
 snd->OUT_DEVICE=sound_device;
 snd->openOut(12000,16,2,SND_LEN);
 try{
 FILE *fp=fopen(rxfile.c_str(),"a");
 DateSeparator='/';
 TimeSeparator=':';
 AnsiString str_t = FormatDateTime("dd/mm/yyyy hh:mm:ss", Now());
 fprintf(fp,"%s SOUND INPUT IS %d\n",str_t.c_str(), sound_device);
 fclose(fp);
 }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{try{
 TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
 ini->WriteBool("TIME_CORRECTION","ENABLE",CheckBox1->Checked);
 delete ini;
 FILE *fp=fopen(rxfile.c_str(),"a");
 DateSeparator='/';
 TimeSeparator=':';
 AnsiString str_t = FormatDateTime("dd/mm/yyyy hh:mm:ss", Now());
 if(CheckBox1->Checked) fprintf(fp,"%s TIME CORRECTION ENABLED \n",str_t.c_str());
 else fprintf(fp,"%s TIME CORRECTION DISABLED \n",str_t.c_str());
 fclose(fp);
 }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
 DateSeparator='/';
 TimeSeparator=':';
 AnsiString str_t = FormatDateTime("dd/mm/yyyy hh:mm:ss", Now());
 Label2->Caption=str_t;
 AnsiString sdf="dF= counting...";

 if(cnt_F>0)sdf.sprintf("dF=%.3f Hz +-%.3f Hz",deltaF,d_deltaF);
 if(d_deltaF>0.01){Form1->Label3->Font->Color=clMaroon;Form1->Label3->Hint="Frequency is unstable, please wait...";}
 else {Form1->Label3->Font->Color=clGreen; Form1->Label3->Hint="Frequency is stable, OK";}
 if(cnt_F<10){Form1->Label3->Font->Color=clGray;Form1->Label3->Hint="Please wait...";}
 Form1->Label3->Caption=sdf;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
 FILE *fp=fopen(rxfile.c_str(),"a");
 DateSeparator='/';
 TimeSeparator=':';
 AnsiString str_t = FormatDateTime("dd/mm/yyyy hh:mm:ss", Now());
 fprintf(fp,"%s EXIT. \n",str_t.c_str());
 fclose(fp);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
  NB_ENABLE=CheckBox2->Checked;
  try{
  TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
  ini->WriteBool("AUDIO","NB_ENABLE",NB_ENABLE);
  delete ini;
  }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton4Click(TObject *Sender)
{float FFF=1000.0;
 if(floor(BPF1->getF0()*12000)!= FFF)    //RWM
  { if(AUDIO_RX_WORKED){SuspendThread(hAudioRx); AUDIO_RX_WORKED=false; Sleep(100);}
    delete BPF1;   delete BPF2;
    BPF1=new TFilter((FFF-BW_RWM)/12000,(FFF+BW_RWM)/12000);
    BPF2=new TFilter((FFF+DF_RWM-BW_RWM)/12000,(FFF+DF_RWM+BW_RWM)/12000);
    //BPF1=new TIIR_DCFHGA(1000, BW_RWM);
    //BPF2=new TIIR_DCFHGA(1000+DF_RWM,BW_RWM);
    BPF_F=new TIIRBPF2(FFF/12000, BW_F/12000);
    BPF_F2=new TIIRBPF2(FFF/12000, BW_F*10.0/12000);
    Panel1->Caption="RWM";
    Form1->StatusBar1->SimpleText="RWM";
    MODE=RWM;
    //CheckBox2->Enabled=false;
    Label3->Caption="dF=___ Hz";
    CNT_Z=CNT_Z_ALL=0;
     cnt_F=0;
     last_rwm_time=time(NULL);
     for(int i=0; i<DF_LEN; i++) df0[i]=0;
    int freq=9995;
    
    try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteInteger("FREQ","DIAL",freq);
    delete ini;
    FILE *fp=fopen(rxfile.c_str(),"a");
    DateSeparator='/';
    TimeSeparator=':';
    AnsiString str_t = FormatDateTime("dd/mm/yyyy hh:mm:ss", Now());
    fprintf(fp,"%s DIAL FREQ = %d kHz\n",str_t.c_str(), freq);
    fclose(fp);
    }catch(...){}
    if(!AUDIO_RX_WORKED){ResumeThread(hAudioRx);}
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
  if(d_deltaF<0.01 && cnt_F>10)
  {
   try{
    FILE *fp=fopen(dffile.c_str(),"w");
    fprintf(fp,"%.3f\n",deltaF);
    fclose(fp);
   }catch(...){}
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer3Timer(TObject *Sender)
{
  if(WRITE_DF)
 {
  Word Hour, Min, Sec, MSec;
  TDateTime dtPresent = Now();
  DecodeTime(dtPresent, Hour, Min, Sec, MSec);
  if(Min%WRITE_DF_PERIOD==0 && Sec==0)
  {
    try{
    DateSeparator='/';
    TimeSeparator=':';
    AnsiString str_t = FormatDateTime("dd/mm/yyyy hh:mm:ss", Now());
    FILE *fp=fopen(dffile.c_str(),"a");
    fprintf(fp,"%s DF=%.3f +-%.3f Hz\n",str_t.c_str(), deltaF, d_deltaF);
    fclose(fp);
    }catch(...){}
  }
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WritedFtoLogFile1Click(TObject *Sender)
{
 if(WritedFtoLogFile1->Checked) WritedFtoLogFile1->Checked=false;
 else WritedFtoLogFile1->Checked=true;
 WRITE_DF=WritedFtoLogFile1->Checked;
 try{
  TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
  ini->WriteBool("FILE","WRITE_DF_TO_FILE",WRITE_DF);
  delete ini;
  }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N5min1Click(TObject *Sender)
{
 N5min1->Checked=true;
 WRITE_DF_PERIOD=5;
 try{
  TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
  ini->WriteInteger("FILE","WRITE_DF_PERIOD_MIN",WRITE_DF_PERIOD);
  delete ini;
  }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N10min1Click(TObject *Sender)
{
  N10min1->Checked=true;
 WRITE_DF_PERIOD=10;
 try{
  TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
  ini->WriteInteger("FILE","WRITE_DF_PERIOD_MIN",WRITE_DF_PERIOD);
  delete ini;
  }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N15min1Click(TObject *Sender)
{
  N15min1->Checked=true;
 WRITE_DF_PERIOD=15;
 try{
  TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
  ini->WriteInteger("FILE","WRITE_DF_PERIOD_MIN",WRITE_DF_PERIOD);
  delete ini;
  }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N20min1Click(TObject *Sender)
{
  N20min1->Checked=true;
 WRITE_DF_PERIOD=20;
 try{
  TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
  ini->WriteInteger("FILE","WRITE_DF_PERIOD_MIN",WRITE_DF_PERIOD);
  delete ini;
  }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N30min1Click(TObject *Sender)
{
  N30min1->Checked=true;
 WRITE_DF_PERIOD=30;
 try{
  TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
  ini->WriteInteger("FILE","WRITE_DF_PERIOD_MIN",WRITE_DF_PERIOD);
  delete ini;
  }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::user1Click(TObject *Sender)
{
 user1->Checked=true;
 WRITE_DF_PERIOD=WRITE_DF_PERIOD_USER;
 try{
  TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
  ini->WriteInteger("FILE","WRITE_DF_PERIOD_MIN",WRITE_DF_PERIOD);
  delete ini;
  }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox3Click(TObject *Sender)
{
  PARITY_CHECK_ENABLE=CheckBox3->Checked;
  try{
  TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
  ini->WriteBool("DATA","PARITY_CHECK_ENABLE",PARITY_CHECK_ENABLE);
  delete ini;
  }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::writedTtologfile1Click(TObject *Sender)
{
  if(writedTtologfile1->Checked) writedTtologfile1->Checked=false;
  else writedTtologfile1->Checked=true;
  WRITE_DT=writedTtologfile1->Checked;
  try{
  TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
  ini->WriteBool("FILE","WRITE_DT_TO_FILE",WRITE_DT);
  delete ini;
  }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N10dB1Click(TObject *Sender)
{
   N10dB1->Checked=true;
   NB_THRESHOLD=10;
   try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteFloat("AUDIO","NB_THRESHOLD_DB",NB_THRESHOLD);
    delete ini;
   }catch(...){}
   NB_THRESHOLD=pow(10,(NB_THRESHOLD/20));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N15dB1Click(TObject *Sender)
{
   N15dB1->Checked=true;
   NB_THRESHOLD=15;
   try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteFloat("AUDIO","NB_THRESHOLD_DB",NB_THRESHOLD);
    delete ini;
   }catch(...){}
   NB_THRESHOLD=pow(10,(NB_THRESHOLD/20));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N20dB1Click(TObject *Sender)
{
   N20dB1->Checked=true;
   NB_THRESHOLD=20;
   try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteFloat("AUDIO","NB_THRESHOLD_DB",NB_THRESHOLD);
    delete ini;
   }catch(...){}
   NB_THRESHOLD=pow(10,(NB_THRESHOLD/20));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N25dB1Click(TObject *Sender)
{
   N25dB1->Checked=true;
   NB_THRESHOLD=25;
   try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteFloat("AUDIO","NB_THRESHOLD_DB",NB_THRESHOLD);
    delete ini;
   }catch(...){}
   NB_THRESHOLD=pow(10,(NB_THRESHOLD/20));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::user2Click(TObject *Sender)
{
   user2->Checked=true;
   NB_THRESHOLD=NB_THRESHOLD_USER;
   try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteFloat("AUDIO","NB_THRESHOLD_DB",NB_THRESHOLD);
    delete ini;
   }catch(...){}
   NB_THRESHOLD=pow(10,(NB_THRESHOLD/20));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N1filterdetector1Click(TObject *Sender)
{
  N1filterdetector1->Checked=true;
  USE_TWO_FILTERS=false;
  ProgressBar1->Visible=USE_TWO_FILTERS;
  try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteBool("AUDIO","DEMOD_USE_2_FILTERS",USE_TWO_FILTERS);
    delete ini;
   }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::twofiltersdetectors1Click(TObject *Sender)
{
 twofiltersdetectors1->Checked=true;
 USE_TWO_FILTERS=true;
 ProgressBar1->Visible=USE_TWO_FILTERS;
 try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteBool("AUDIO","DEMOD_USE_2_FILTERS",USE_TWO_FILTERS);
    delete ini;
   }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SoundInputLEFT1Click(TObject *Sender)
{
 SoundInputLEFT1->Checked=true;
 CHANNEL_LEFT=true;
 Label1->Caption="Sound Input (L):";
 try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteBool("AUDIO","USE_LEFT_CHANNEL",CHANNEL_LEFT);
    delete ini;
   }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SoundInputRIGHT1Click(TObject *Sender)
{
 SoundInputRIGHT1->Checked=true;
 CHANNEL_LEFT=false;
 Label1->Caption="Sound Input (R):";
 try{
    TIniFile *ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
    ini->WriteBool("AUDIO","USE_LEFT_CHANNEL",CHANNEL_LEFT);
    delete ini;
   }catch(...){}
}
//---------------------------------------------------------------------------

